/*
 * DemosceneMusic - TrackDerivativeAccessor.java - Copyright © 2012 David Roden
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package net.pterodactylus.demoscenemusic.template;

import net.pterodactylus.demoscenemusic.core.Core;
import net.pterodactylus.demoscenemusic.data.TrackDerivative;
import net.pterodactylus.util.template.ReflectionAccessor;
import net.pterodactylus.util.template.TemplateContext;

/**
 * {@link ReflectionAccessor} implementation that adds “size” and “path”
 * properties to a {@link TrackDerivative}.
 *
 * @author <a href="mailto:bombe@pterodactylus.net">David ‘Bombe’ Roden</a>
 */
public class TrackDerivativeAccessor extends ReflectionAccessor {

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Object get(TemplateContext templateContext, Object object, String member) {
		TrackDerivative trackDerivative = (TrackDerivative) object;
		if ("path".equals(member)) {
			return ((Core) templateContext.get("core")).getDataDirectory().getPath(trackDerivative.getId());
		} else if ("size".equals(member)) {
			return ((Core) templateContext.get("core")).getDataDirectory().getFile(trackDerivative.getId()).length();
		}
		return super.get(templateContext, object, member);
	}

}
